if mods["PlanetsLib"] then  
    -- 定义所有的 space-location 数据
    local space_locations = {
        {
            type = "space-location",
            name = "Nauvis-background-1",
            starmap_icon = "__Better_Starmap_Background__/graphics/icons/starmap_background_star_01.png",
            starmap_icon_size = 4096,
            orbit = {
                parent = {
                    type = "space-location",
                    name = "star",
                },
                distance = 1024 * 2^(1/2) / 32,
                orientation = 0.875,
            },
            sprite_only = true,
            magnitude = 64,
        },
        {
            type = "space-location",
            name = "Nauvis-background-2",
            starmap_icon = "__Better_Starmap_Background__/graphics/icons/starmap_background_star_02.png",
            starmap_icon_size = 4096,
            orbit = {
                parent = {
                    type = "space-location",
                    name = "star",
                },
                distance = 1024 * 2^(1/2) / 32,
                orientation = 0.125,
            },
            sprite_only = true,
            magnitude = 64,
        },
        {
            type = "space-location",
            name = "Nauvis-background-3",
            starmap_icon = "__Better_Starmap_Background__/graphics/icons/starmap_background_star_03.png",
            starmap_icon_size = 4096,
            orbit = {
                parent = {
                    type = "space-location",
                    name = "star",
                },
                distance = 1024 * 2^(1/2) / 32,
                orientation = 0.625,
            },
            sprite_only = true,
            magnitude = 64,
        },
        {
            type = "space-location",
            name = "Nauvis-background-4",
            starmap_icon = "__Better_Starmap_Background__/graphics/icons/starmap_background_star_04.png",
            starmap_icon_size = 4096,
            orbit = {
                parent = {
                    type = "space-location",
                    name = "star",
                },
                distance = 1024 * 2^(1/2) / 32,
                orientation = 0.375,
            },
            sprite_only = true,
            magnitude = 64,
        },
        {
            type = "space-location",
            name = "Nauvis-star",
            starmap_icon = "__core__/graphics/icons/starmap-star.png",
            starmap_icon_size = 512,
            orbit = {
                parent = {
                    type = "space-location",
                    name = "star",
                },
                distance = 0,
                orientation = 0,
            },
            sprite_only = true,
            magnitude = 8,
        },
    }

    -- 检测是否存在 Tiered-Solar-System 模组，若存在，则为每个 space-location 添加 tier = -1
    if mods["Tiered-Solar-System"] then
        for _, location in pairs(space_locations) do
            location.tier = -1
        end
    end

    -- 扩展 PlanetsLib 数据
    PlanetsLib:extend(space_locations)
else
    if data.raw["utility-sprites"] and data.raw["utility-sprites"]["default"] then
        data.raw["utility-sprites"]["default"]["starmap_star"] = {
        type = "sprite",
        layers = {
            {
            filename = "__Better_Starmap_Background__/graphics/icons/starmap_background_star_01.png",
            size = 4096,
            scale = 0.5,
            shift = {-1024, -1024},
            },
            {
            filename = "__Better_Starmap_Background__/graphics/icons/starmap_background_star_02.png",
            size = 4096,
            scale = 0.5,
            shift = {1024, -1024},
            },
            {
            filename = "__Better_Starmap_Background__/graphics/icons/starmap_background_star_03.png",
            size = 4096,
            scale = 0.5,
            shift = {-1024, 1024},
            },
            {
            filename = "__Better_Starmap_Background__/graphics/icons/starmap_background_star_04.png",
            size = 4096,
            scale = 0.5,
            shift = {1024, 1024},
            },
            {
            filename = "__core__/graphics/icons/starmap-star.png",
            size = 512,
            scale = 0.5,
            shift = {0, 0},
            draw_as_light = true,
            },
        },
        }
    end
end