local filterOnOnlyThis = nil
local printPrefix = '[OreEraser]'


script.on_event(defines.events.on_player_alt_selected_area, function(event)
	local player = game.players[event.player_index]
	local item = event.item
	local entities = event.entities

	if item == "ore-eraser" then
		for _,entity in ipairs(entities) do
			if entity.type == "resource" then
				filterOnOnlyThis = entity.name
				player.print(printPrefix .. " '" .. entity.name .. "' will only be remove next time!")
				break
			end
		end
	end
end)


script.on_event(defines.events.on_player_selected_area, function(event)
	local player = game.players[event.player_index]
	local item = event.item
	local entities = event.entities

	local wasFiltering = false

	if item == "ore-eraser" then
		for _,entity in ipairs(entities) do
			if entity.type == "resource" then
					
				if filterOnOnlyThis ~= nil then
					if entity.name == filterOnOnlyThis then
						wasFiltering = true
						entity.destroy()
					end
				else
					entity.destroy()
				end
			end
		end
	end

	if wasFiltering then
		filterOnOnlyThis = nil
		player.print(printPrefix .. ' Filter reset.')
	end
end)

script.on_event(defines.events.on_player_dropped_item, function(event)
	if event.entity ~= nil then
		if event.entity.stack ~= nil then
			if event.entity.stack.name == "ore-eraser" then
				event.entity.stack.clear()
			end
		end
	end
end)



